<?php

function binary_search($list, $begin, $end, $target){
    if ($end < $begin) return "$target is not found!\n";
    
    $middle = floor( ($begin + $end)/2 );
    if ($list[$middle] == $target) {
        return "sample[$middle] => $target\n";
    }
    elseif ($target < $list[$middle]) {
        // recursive call itself on [begin, middle - 1]
        return binary_search($list, $begin, $middle - 1, $target);
    }
    else {
        // recursive call itself on [middle + 1, end]
        return binary_search($list, $middle + 1, $end, $target);
    }
}

// main
echo "\n******* Binary search *******\n\n";
$sample = [2, 7, 22, 25, 27, 33, 45, 62, 67, 69, 75, 76, 88, 89, 91, 94, 98];
$target = ($argc > 1) ? $argv[1] : '7';

echo binary_search($sample, 0, count($sample), $target);


